#include <zephyr/kernel.h>
#include <zephyr/device.h>
#include <zephyr/drivers/uart.h>
#include <stdio.h>
#include <string.h>


//add from RPI
#include <stdlib.h>
#include <stdbool.h>
#include <unistd.h>
#include <fcntl.h>
#include <errno.h>



#define EPC_LENGTH 25
#define MAX_EPC 115
#define DELAY_MS 150

typedef struct {
    unsigned char EPC[12];      // 12-byte EPC
    unsigned short initialRSSI; // Initial RSSI
    unsigned short timestamp;   // Timestamp in milliseconds
    unsigned char count;        // Count of detections
    unsigned short minRSSI;     // Minimum RSSI
    unsigned short maxRSSI;     // Maximum RSSI
} EPCRecord;

EPCRecord epcArray[MAX_EPC];  // Array to store EPC records
int epcCount = 0;             // Counter for unique EPCs



const struct device *myuart1 = DEVICE_DT_GET(DT_NODELABEL(uart1));

struct uart_config uart_cfg = {
    .baudrate = 9600,
    .data_bits = UART_CFG_DATA_BITS_8,
    .parity = UART_CFG_PARITY_NONE,
    .stop_bits = UART_CFG_STOP_BITS_1,
    .flow_ctrl = UART_CFG_FLOW_CTRL_NONE,

};

void send_str(const struct device *uart,  char *str, size_t size)
{
int ret;

	ret = uart_tx(uart, str, size, SYS_FOREVER_US);
	if (ret) {
		printf("Got 1");
	}

    printf("\n");
k_sleep(K_MSEC(10));
}

void recv_str(const struct device *uart, char *str)
{
int ret;

	ret = uart_rx_enable(uart ,str,100,100);
	if (ret) {
		printf("Got 1");
	}
    printf("\n");
}

int main(void)
{
int rc;
    unsigned char recv_buf[64];
    int i = 10;


if (!device_is_ready(myuart1)) 
{
    printf("UART1 device not ready\n");
} else {
    printf("UART1 device ready\n");

}

rc = uart_configure(myuart1, &uart_cfg);
if (rc != 0) {
        printf("Could not configure device uart1\n");
} else {
        printf("Configure device uart1\n");
}


    // Initial command to send
    unsigned char init_command[] = {0xC8, 0x8C, 0x00, 0x0A, 0x82, 0x00, 0x00, 0x88, 0x0D, 0x0A};
    send_str(myuart1, init_command, sizeof(init_command));


    i = 10;
    while (i--) {

        /* Wait some time for the messages to arrive to the second uart. */
        k_sleep(K_MSEC(100));
        recv_str(myuart1, recv_buf);
        printf("Received buffer: %s\n", recv_buf);

    }
    printf("the end");
//         send_str(uart1, send_buf);   return 0;
};